*	Modified for BYTE qdata. qscale should match prelearn.
     
	program main

	integer ITER
	integer FILES
	integer WORDS
	integer DETS
	integer TAPS
	integer NPOINTS
	integer FILESPERBLOCK
	real tau
	real qscale
	real qoffset

	parameter (ITER=64)
	parameter (FILES=10)
	parameter (FILESPERBLOCK=1)
	parameter (WORDS=10)
	parameter (DETS=16)
	parameter (TAPS=10)
	parameter (NPOINTS=19)
	parameter (tau=.03)
	parameter (qscale=10.)
	parameter (qoffset=128)

	integer nword
	integer ndet
	integer ntap
	integer nfile
	integer npoint
	integer niter
	integer diagflag
	integer taplimit(WORDS)
	integer ihelp
	integer odd
	integer nblock
	integer currentblocksize
	integer temp

	integer spword(FILES) 
*	integer otherword(FILES) 
*	integer anotherword(FILES) 
	integer njustify(FILES)
	real uinput
	real voutput
	real delconn(WORDS,DETS,TAPS)
	real globinh(WORDS)
	real accdelconn(WORDS,DETS,TAPS)
	real oldaccdelconn(WORDS,DETS,TAPS)
	real accglobinh(WORDS)
	real oldaccglobinh(WORDS)
	real intdeldata(NPOINTS,TAPS,DETS,FILESPERBLOCK)
	byte byteintdeldata(NPOINTS,TAPS,DETS,FILESPERBLOCK)
	real vdesire
	real turnon
	real learncf(WORDS,DETS,TAPS)
	real learncg(WORDS)

	logical oldfile

*-------------------------------------------------------------
*	Print the parameters	
*
	
	print*,'ITER=',ITER
	print*,'FILES=',FILES
	print*,'WORDS=',WORDS
	print*,'DETS=',DETS
	print*,'TAPS=',TAPS
	print*,'NPOINTS=',NPOINTS
	print*,'learncoef=',learncoef
	print*,'tau=',tau

*------------------------------------------------------------
*	Limit the logest delay line tap per word	
*	according to the meand word length.
*
	taplimit(1)=9
	taplimit(2)=7
	taplimit(3)=6
	taplimit(4)=8
	taplimit(5)=7
	taplimit(6)=8
	taplimit(7)=9
	taplimit(8)=9
	taplimit(9)=7
	taplimit(10)=8

*------------------------------------------------------------
*	load the connections
*
	inquire (file='connections',exist=oldfile)
        if (oldfile) then
	  open(unit=7,file='connections',status='old')
        else
          stop '"connections" file does not exist.  Program stopped.'
        end if


	do 100 nword=1,WORDS
	do 110 ndet=1,DETS
	do 120 ntap=1,TAPS

	read (7,*) delconn(nword,ndet,ntap)

120	continue
110	continue
100	continue

	do 130 nword=1,WORDS

	read (7,*) globinh(nword)

130	continue

	do 140 nword=1,WORDS
	do 150 ndet=1,DETS
	do 160 ntap=1,TAPS

	read (7,*) learncf(nword,ndet,ntap)

160	continue
150	continue
140	continue

	do 170 nword=1,WORDS

	read (7,*) learncg(nword)

170	continue

	close(7)

*-------------------------------------------------------------
*	Read in pdata and sex data

	inquire (file='pdata',exist=oldfile)
        if (oldfile) then
          open(unit=7,file='pdata',status='old')
        else
          stop '"pdata" file does not exist.  Program stopped.'
        end if

	read(7,*) (spword(nfile),
*     :  otherword(nfile),anotherword(nfile),
     :  njustify(nfile),nfile=1,FILES)

	close(7)

*-------------------------------------------------------------
*	Create the gain lookup table
*
	call gaincreate()
	errorflag=0.

*-------------------------------------------------------------
*	Read in a gain lookup table
*
	Call gainrel()

*=============================================================
*	Loop over the iterations
*
	diagflag=0
	do 200 niter=1,ITER
	
	print*,'Beginning iteration number ',niter
	diagflag=diagflag+1
	odd=niter-2*(niter/2)

*-------------------------------------------------------------
*	Initialize the accumulated gradient arrays
*
	do 300 nword=1,WORDS

	accglobinh(nword)=0.
	 
	do 310 ndet=1,DETS
	do 320 ntap=1,TAPS

	accdelconn(nword,ndet,ntap)=0.	

320	continue
310	continue
300	continue

*-------------------------------------------------------------

	nblocks=FILES/FILESPERBLOCK
*	print*,'nblocks=',nblocks

	inquire(file='qdata',exist=oldfile)
        if (oldfile) then
          open(unit=10,file='qdata',status='old',form='unformatted',
     :    access='direct',recl=DETS*TAPS*NPOINTS*FILESPERBLOCK)
	else
          stop 'File "qdata" does not exist.  Program stopped.'
        end if

	
*-------------------------------------------------------------
*	loop over blocks 

	do 425 nblock=1,nblocks+1

 	if(nblock.lt.nblocks+1) then
		currentblocksize=FILESPERBLOCK
	endif
	if (nblock.eq.nblocks+1) then
		currentblocksize=FILES-(nblocks*FILESPERBLOCK)
	endif
*	print*,'currentblocksize=',currentblocksize
	read(10,rec=nblock,err=430,end=430) byteintdeldata

430	continue

*--------------------------------------------------------
*	Convert to real data 
*
	do 440 nfile=1,currentblocksize
	do 450 ndet=1,DETS
	do 460 ntap=1,TAPS
	do 470 npoint=1,NPOINTS

	temp = byteintdeldata(npoint,ntap,ndet,nfile)
	intdeldata(npoint,ntap,ndet,nfile)=
     :  (temp+qoffset)/qscale

470	continue
460	continue
450	continue
440	continue
*--------------------------------------------------------
*	loop over the files

	do 400 nfile=1,currentblocksize


*--------------------------------------------------------
*	Loop over points and words
*
	
	do 500 n=1,10
	npoint=2*n-odd
	if(npoint.eq.20) npoint=19
	do 510 nword=1,WORDS
	
	uinput = 0.

	do 520  ndet=1,DETS
	do 530  ntap=1,taplimit(nword)

	uinput = uinput+intdeldata(npoint,ntap,ndet,nfile)*
     :   delconn(nword,ndet,ntap)

530	continue
520	continue

	voutput = gain(uinput+(globinh(nword)*tau))

	if((nword-1).eq.spword((nblock-1)*FILESPERBLOCK+nfile)
     :  .and.npoint.eq.19) then
	   
	   vdesire=1.0
	   turnon=1.0

	elseif((nword-1).eq.spword((nblock-1)*FILESPERBLOCK+nfile)
     :  .and.npoint.ne.19) then

 	   turnon=0.0

	else
	 
	   vdesire=0.0
	   turnon=1.0

	endif	
*	if((nword-1).eq.otherword((nblock-1)*FILESPERBLOCK+nfile)
*     :  .and.otherword((nblock-1)*FILESPERBLOCK+nfile).ne.
*     :  spword((nblock-1)*FILESPERBLOCK+nfile))turnon=0.
	
*	if((nword-1).eq.anotherword((nblock-1)*FILESPERBLOCK+nfile)
*     :  .and.anotherword((nblock-1)*FILESPERBLOCK+nfile).ne.
*     :  spword((nblock-1)*FILESPERBLOCK+nfile))turnon=0.
*--------------------------------------------------
*	Print diagnostics
*
*	ihelp=nfile-(nfile/20)*20
	
*	if(diagflag.eq.ITER.and.npoint.eq.19.and.ihelp.eq.0) then

*	   print*,'Target=',vdesire,'  Observed=',voutput

*	endif
*--------------------------------------------------
* 	Add to gradient	
*
	do 540 ndet=1,DETS
	do 550 ntap=1,taplimit(nword)
	accdelconn(nword,ndet,ntap)=accdelconn(nword,ndet,ntap)+
     :  turnon*(vdesire-voutput)*intdeldata(npoint,ntap,ndet,nfile)
550	continue	
540	continue

	accglobinh(nword) = accglobinh(nword)+
     :  turnon*(vdesire-voutput)

*	end of loop over nword
510	continue	
*	end of loop over npoint
500	continue
*-------------------------------------------------------
	
*	end of loop over files
400	continue
	
*	end of loop over blocks 
425	continue 
*-------------------------------------------------------------
* 	Use gradient to update connections and thresholds	
*
	do 600 nword=1,WORDS
	globinh(nword)=globinh(nword)+(0.5*learncg(nword)*accglobinh(nword))
	if(niter.eq.1) go to 618

	yyy=0.5*learncg(nword)*abs(accglobinh(nword)-oldaccglobinh(nword))
	if(yyy.gt..005) learncg(nword)=learncg(nword)/2.
	if(yyy.lt..005) learncg(nword)=learncg(nword)*1.2
	if (learncg(nword).gt.90000.) learncg(nword) = 90000.
	if (learncg(nword).lt.0.00001) learncg(nword) = 0.00001

618	oldaccglobinh(nword)=accglobinh(nword)
	
	do 610 ndet=1,DETS
	do 620 ntap=1,taplimit(nword)
	delconn(nword,ndet,ntap)=delconn(nword,ndet,ntap)+
     :  (accdelconn(nword,ndet,ntap)*learncf(nword,ndet,ntap))

	if (delconn(nword,ndet,ntap).gt.9000.) then
	  delconn(nword,ndet,ntap)=9000.
	elseif (delconn(nword,ndet,ntap).lt.-9000.) then
	  delconn(nword,ndet,ntap)=-9000.
	endif

	if(niter.eq.1) go to 619
	yyy=abs(accdelconn(nword,ndet,ntap)-oldaccdelconn(nword,ndet,ntap))
	if(yyy*learncf(nword,ndet,ntap).gt..001) learncf(nword,ndet,ntap)
     :	=learncf(nword,ndet,ntap)/2.
	if(yyy*learncf(nword,ndet,ntap).lt..001) learncf(nword,ndet,ntap)
     :	=learncf(nword,ndet,ntap)*1.2
	if (learncf(nword,ndet,ntap).lt.0.00001) learncf(nword,ndet,ntap)
     :  = 0.00001
	if (learncf(nword,ndet,ntap).gt.90000.) learncf(nword,ndet,ntap)
     :   = 90000.
619	oldaccdelconn(nword,ndet,ntap)=accdelconn(nword,ndet,ntap)
      
620	continue
610	continue
600	continue

	close(10)

*	end of loop over iterations
200	continue
*=============================================================
*	Store the connections and learncoef
*
	
	open(unit=7,file='connections',status='old')
2000	format(F12.6)
	write(7,2000)(((delconn(nword,ndet,ntap),ntap=1,TAPS),
     :  ndet=1,DETS), nword=1,WORDS)
    	write(7,2000)(globinh(nword),nword=1,WORDS)

	write(7,2000)(((learncf(nword,ndet,ntap),ntap=1,TAPS),
     :  ndet=1,DETS), nword=1,WORDS)
    	write(7,2000)(learncg(nword),nword=1,WORDS)

	close(7)

	stop
	end
*=============================================================
*=============================================================
*	Subroutine to create the input-output relation	
*

	subroutine gaincreate()

	real iorv(2001)
	real iorr(2001)
	real iowidth

	parameter (iowidth=.03)	
	
	common/lookup/iorv,iorr
	
	do 100 n=1,2001

	
	iorv(n)=(1.0/2.0)*(1+tanh((n-1001.0)/(iowidth*1000)))

100	continue

	do 200 n=1,2000

	iorr(n)=iorv(n+1)-iorv(n)
	
200	continue
*-------------------------------------------------------------
*	Store the tables in a file so that other programs can
*	use the same values.

2200	format(F11.9)
	open(unit=7,file='gaindata')
	write(7,2200)iowidth
	write(7,2200)(iorv(n),n=1,2001)
	write(7,2200)(iorr(n),n=1,2001)
	close(7)

	return
	end

*-------------------------------------------------------------
*	Subroutine to create the input-ouput relation	
*
	subroutine gainrel()
	real iorv(2001)
	real iorr(2001)
	real iowidth

	common/lookup/iorv,iorr

*-------------------------------------------------------------
*	Read the tables in from a file named gaindata 
*	Tables created using gaincreate(). The io_width
*	used the table is the first number read in. 

2300	format(F11.9)
	open(unit=7,file='gaindata',status='old')
	read(7,2300)iowidth
	print*,'reading gaindata file, iowidth=',iowidth
	read(7,2300)(iorv(n),n=1,2001)
	read(7,2300)(iorr(n),n=1,2001)
	close(7)

	return
	end

*-------------------------------------------------------------
*	Subroutine to create the input-ouput relation	
*

	real function gain(x)
	real x


	integer xi
	real xr
	real iorv(2001)
	real iorr(2001)

	common/lookup/iorv,iorr

	if(x.le.-1.0) then

		gain=iorv(1)

	elseif(x.ge.1.0) then

		gain=iorv(2001)
	
	else

		xi=int(x*1000.0)
		xr=(x*1000.0)-xi


	  if(x.ge.0.0) then

	    gain= iorv(xi+1001)+(xr*iorr(xi+1001))

	  elseif(x.lt.0.0) then

	    gain= iorv(xi+1000)+((1+xr)*iorr(xi+1000))

 	  endif

	endif	

	end


