/*
 * tststats.c reads in the recognition unit outputs of N_points
 * long from the unformatted data file entered on the command
 * line. The pdata file is used to supply the data on the
 * correct unit for the given segment. If the correct recognition
 * unit is only driven on below the 0.5 level, or an
 * incorrect unit is driven above 0.5, the segment is flagged
 * and an entry is written in the file badsegments. Detailed
 * errors are written in the file testdata. At the end
 * of the analysis, percent correct statistics are appended
 * to the end of the badsegments file and printed on the terminal.
 */

#include <stdio.h>

#define N_words	10
#define N_points 90
#define N_files	2220


float v_recog[N_words][N_points];

main(argc,argv)
int argc;
char *argv[];
{
	int i;

	int n_word,n_step,n_file;
	int n_read;
	int n_show;
	int sp_word;
	int n_justify;
	int fd; 
	int correct_wrong;
	int incorrect_wrong;
	int bad_segment;
	int bad_flag;
	FILE *fp,*fp1;
	float maxv;
	float sumv;
	float sp_v;
	int max_word;

	char message[80];
	char heading[80];


	fd=open(*++argv,0);
	fp=fopen("pdata","r");	
	fp1=fopen("testdata","w");



	for(n_file=0;n_file<N_files;n_file++){

	n_read=read(fd,v_recog,4*N_words*N_points);

	fscanf(fp,"%d",&sp_word);
	fscanf(fp,"%d",&n_justify);

	bad_flag=0;	
	maxv=0;
	sp_v=0;

	for(n_word=0;n_word<N_words;n_word++){
	sumv=0.;
	for(n_step=0;n_step<N_points;n_step++){
		   sumv += v_recog[n_word][n_step];
	 
	}/*loop on n_step*/
	
	if (sumv>maxv) {
	  maxv = sumv;
	  max_word = n_word;
	}

	if (n_word==sp_word){
	  sp_v = sumv;
	}

	}/*loop on n_word*/
	
	if(max_word!=sp_word){
		correct_wrong++;
		bad_flag=1;
		fprintf(fp1,"%d file: Sp_word(%d) = %f;  Incorrect word(%d) = %f\n",
			n_file+1,sp_word,sp_v,max_word,maxv);
	}
	
	if(bad_flag==1){
		bad_segment++;
	}
	}/*loop on n_file*/
	printf("Number Correct:%d out of %d files;\
	Percent Correct:%f\n",
	(N_files-bad_segment),N_files,
	100.*(N_files-bad_segment)/N_files);
	
	fprintf(fp1,"Number Correct:%d out of %d files;\
	Percent Correct:%f\n",
	(N_files-bad_segment),N_files,
	100.*(N_files-bad_segment)/N_files);
	close(fd);
	close(fp);
	close(fp1);
}



