/*
 * rejust.c
 * rejust.c self-justifies the endpoints; the program places the 
 * new end point at the point of maximum response of a (partially)
 * trained network.  
 * NOTE: the program uses old endpoints if maximum response(vmax)<0.1
 */

#include <stdio.h>
#include <string.h>

#define N_words	10
#define N_points 90
#define N_files	10

float threshold=0.50;

float v_recog[N_words][N_points];

main(argc,argv)
int argc;
char *argv[];
{
	int i;
	int ok_flag;
	int n_word,n_step,n_file;
	int n_read;
	int n_show;
	int sp_word;
	int n_justify;
	int new_justify;
	int error;
	int fd; 
	int correct_wrong;
	int incorrect_wrong;
	int bad_segment;
	int bad_flag;
	FILE *fp,*fp1,*fp3;
	float maxv;

	char message[80];
	char heading[80];

	printf("Threshold=%f\n",threshold);	

	fd=open(*++argv,0);
	fp=fopen("pdata","r");	
	fp1=fopen("testdata","w");
	fp3=fopen("newpdata","w");



	for(n_file=0;n_file<N_files;n_file++){

	n_read=read(fd,v_recog,4*N_words*N_points);

	fscanf(fp,"%d",&sp_word);
	fscanf(fp,"%d",&n_justify);

	ok_flag=1;
	bad_flag=0;	
	for(n_word=0;n_word<N_words;n_word++){
	maxv=0.;
	for(n_step=0;n_step<N_points;n_step++){
		if(v_recog[n_word][n_step]>maxv){
		new_justify=n_step;
		   maxv=v_recog[n_word][n_step];
		}

		if((n_word!=sp_word)&&(v_recog[n_word][n_step]>0.5)&&
		(v_recog[n_word][n_step]>v_recog[sp_word][n_step]))ok_flag=0; 
	}/*loop on n_step*/
	
	if((n_word==sp_word)&&(maxv<threshold)){
		correct_wrong++;
		bad_flag=1;
		fprintf(fp1,"%d file: Sp_word=%d: Error: Correct =%f\n",
			n_file+1,sp_word,maxv);
	}
	if ((n_word!=sp_word)&&(maxv>=threshold)) {
		incorrect_wrong++;	
		bad_flag=1;
		fprintf(fp1,"%d file: Sp_word=%d: Error: Incorrect word(%d) = %f: at %d ok_flag = %d\n",
			n_file+1,sp_word,n_word,maxv,new_justify,ok_flag);
	}
	if(n_word==sp_word){
	fprintf(fp3,"%d\n",sp_word);
	new_justify=200*(new_justify+1);
	if(maxv<0.1) new_justify=n_justify;
	fprintf(fp3,"%d\n",new_justify);
	}
	}/*loop on n_word*/
	if(bad_flag==1){
		bad_segment++;
	}
	}/*loop on n_file*/
	printf("Number Correct:%d out of %d files;\
	Percent Correct:%f\n",
	(N_files-bad_segment),N_files,
	100.*(N_files-bad_segment)/N_files);
	printf("Number low value of correct unit: %d\
  Percent:%f\n",
		correct_wrong,100.*correct_wrong/N_files);
	printf("Number high value of incorrect unit: %d\
  Percent:%f\n",
		incorrect_wrong,100.*incorrect_wrong/ N_files);
	fprintf(fp1,"Number Correct:%d out of %d files;\
	Percent Correct:%f\n",
	(N_files-bad_segment),N_files,
	100.*(N_files-bad_segment)/N_files);
	fprintf(fp1,"Number low value of correct unit: %d\
  Percent:%f\n",
		correct_wrong,100.*correct_wrong/N_files);
	fprintf(fp1,"Number high value of incorrect unit: %d\
  Percent:%f\n",
		incorrect_wrong,100.*incorrect_wrong/ N_files);
	close(fd);
	close(fp);
	close(fp1);
	close(fp3);
}




